#line 1 "F:/MikroC/fader/main.c"
#line 1 "f:/mikroc/fader/fader.h"
#line 1 "f:/mikroc/fader/types.h"
#line 14 "f:/mikroc/fader/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 20 "f:/mikroc/fader/fader.h"
 typedef enum {
 FADE_IN = 0,
 FADE_OUT
 } eFadeDirections;

 typedef enum {
 SINGLE_FADER = 0,
 MULTIPLE_FADERS
 } eFadeMode;

 typedef struct _faderNode {
 unsigned uBounce : 1;
 unsigned uDir : 1;
 unsigned uEnable : 1;
 unsigned uLoop : 1;
 unsigned uMode : 1;
 unsigned uState : 1;
 ushort* pPort;
 byte bytPin;
 byte bytBounces;
 byte bytDelta;
 uint uintCount;
 uint uintDutyTime;
 int intOffTime;
 uint uintRepeats;
 uint uintRptCtr;

 struct _faderNode* pNext;
 } faderDef;


 boolean initFader(faderDef* pF,
 ushort* pPort,
 eFadeMode eMode,
 byte bytPin,
 eFadeDirections eDir,
 boolean blnLoop,
 boolean blnBounce,
 boolean blnEnable,
 byte bytDelta,
 uint uintRepeats);
 void serviceFaders(void);
#line 27 "F:/MikroC/fader/main.c"
static volatile faderDef aryFaders[ 2 ];
#line 31 "F:/MikroC/fader/main.c"
void interrupt() {
 if ( TMR0IF_bit ) {
 serviceFaders();
 TMR0H = 0xFF;
 TMR0L = 0x38;
 TMR0IF_bit = 0;
 }
}
#line 42 "F:/MikroC/fader/main.c"
void main() {
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ANSELE = 0;
 TRISB = 0;
 TRISC = 0;
 TRISD = 0;
 TRISE = 0x0f;
 LATB = 0;
 LATC = 0;
 LATD = 0;

 initFader(&aryFaders[0], &LATC, MULTIPLE_FADERS, 0x55, FADE_IN, TRUE, TRUE, TRUE,
 3,  0 );
 initFader(&aryFaders[1], &LATD, MULTIPLE_FADERS, 0xaa, FADE_IN, TRUE, TRUE, TRUE,
 5,  0 );






 T0CON.TMR0ON = 1;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 1;
 T0CON.T0PS2 = 0;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;
 TMR0H = 0xFF;
 TMR0L = 0x38;
 TMR0IE_bit = 1;

 GIE_bit = 1;

 while (1) {
 }
}
